#
# Copyright (c) 2001-2002 Conexant Systems, Inc.
# 
# 1.   Permitted use. Redistribution and use in source and binary forms,
# with or without modification, are permitted under the terms set forth
# herein.
# 
# 2.   Disclaimer of Warranties. CONEXANT AND OTHER CONTRIBUTORS MAKE NO
# REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.
# IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTIES OF ANY KIND.
# CONEXANT AND OTHER CONTRIBUTORS DISCLAIMS ALL WARRANTIES WITH REGARD TO
# THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
# FOR A PARTICULAR PURPOSE, GOOD TITLE AND AGAINST INFRINGEMENT.
# 
# This software has not been formally tested, and there is no guarantee that
# it is free of errors including, but not limited to, bugs, defects,
# interrupted operation, or unexpected results. Any use of this software is
# at user's own risk.
# 
# 3.   No Liability.
# 
# (a) Conexant or contributors shall not be responsible for any loss or
# damage to Company, its customers, or any third parties for any reason
# whatsoever, and CONEXANT OR CONTRIBUTORS SHALL NOT BE LIABLE FOR ANY
# ACTUAL, DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR OTHER LEGAL THEORY OF
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
# WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
# OF SUCH DAMAGE.
# 
# (b) User agrees to hold Conexant and contributors harmless from any
# liability, loss, cost, damage or expense, including attorney's fees,
# as a result of any claims which may be made by any person, including
# but not limited to User, its agents and employees, its customers, or
# any third parties that arise out of or result from the manufacture,
# delivery, actual or alleged ownership, performance, use, operation
# or possession of the software furnished hereunder, whether such claims
# are based on negligence, breach of contract, absolute liability or any
# other legal theory.
# 
# 4.   Notices. User hereby agrees not to remove, alter or destroy any
# copyright, trademark, credits, other proprietary notices or confidential
# legends placed upon, contained within or associated with the Software,
# and shall include all such unaltered copyright, trademark, credits,
# other proprietary notices or confidential legends on or in every copy of
# the Software.
#

# set _target_kernel to generic if it wasn't defined on the command-line
%if %{expand:%{?_target_kernel:0}%{!?_target_kernel:1}}
%define _target_kernel generic
%endif

%if "%{_target_kernel}" == "generic"
%define ver      0.4mbsibeta02122500
%define rel      1
%define automrecomp 1
%else
%define ver      0.4mbsibeta02122500k%(eval echo %{_target_kernel} | sed 's/-/_/g')
%define rel      1%{_target_distro}
%define automrecomp 0
%endif

%define debug_build 0

# Note that this is NOT a relocatable package

# Even though newer versions of RPM provide definitions for these,
# we must still accomodate the older ones
%define prefix   /usr
%define etcdir   /etc
%define libdir   %{prefix}/lib
%define sbindir  %{prefix}/sbin
%define bindir   %{prefix}/bin

Summary:   Conexant RIPTIDE audio/communication controller driver for Linux
Name:      riptide
ExclusiveOS: Linux
%if "%{_target_kernel}" == "generic"
ExclusiveArch: athlon i686 i586 i486 i386
%else
ExclusiveArch: %{_target_cpu}
%endif
Version:   %ver
Release:   %rel
Vendor:	   MBSI (Marc Boucher) & Conexant Systems Inc.
Copyright: Freely redistributable and some GPL
Group:     System Environment/Kernel
Source:    riptide-0.4mbsibeta02122500.tar.gz
URL:       http://www.mbsi.ca/cnxtlindrv/riptide
BuildRoot: %{_tmppath}/riptide-%{PACKAGE_VERSION}-root
Packager:  Marc Boucher <marc+riptide@mbsi.ca>
Requires:  pciutils
Autoreq:   0

%description
Conexant RIPTIDE audio/communication controller driver for Linux

Copyright (c) 2001-2002 Conexant Systems, Inc.

1.   Permitted use. Redistribution and use in source and binary forms,
with or without modification, are permitted under the terms set forth
herein.

2.   Disclaimer of Warranties. CONEXANT AND OTHER CONTRIBUTORS MAKE NO
REPRESENTATION ABOUT THE SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.
IT IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTIES OF ANY KIND.
CONEXANT AND OTHER CONTRIBUTORS DISCLAIMS ALL WARRANTIES WITH REGARD TO
THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
FOR A PARTICULAR PURPOSE, GOOD TITLE AND AGAINST INFRINGEMENT.

This software has not been formally tested, and there is no guarantee that
it is free of errors including, but not limited to, bugs, defects,
interrupted operation, or unexpected results. Any use of this software is
at user's own risk.

3.   No Liability.

(a) Conexant or contributors shall not be responsible for any loss or
damage to Company, its customers, or any third parties for any reason
whatsoever, and CONEXANT OR CONTRIBUTORS SHALL NOT BE LIABLE FOR ANY
ACTUAL, DIRECT, INDIRECT, SPECIAL, PUNITIVE, INCIDENTAL, OR CONSEQUENTIAL
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
HOWEVER CAUSED, WHETHER IN CONTRACT, STRICT OR OTHER LEGAL THEORY OF
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY
OF SUCH DAMAGE.

(b) User agrees to hold Conexant and contributors harmless from any
liability, loss, cost, damage or expense, including attorney's fees,
as a result of any claims which may be made by any person, including
but not limited to User, its agents and employees, its customers, or
any third parties that arise out of or result from the manufacture,
delivery, actual or alleged ownership, performance, use, operation
or possession of the software furnished hereunder, whether such claims
are based on negligence, breach of contract, absolute liability or any
other legal theory.

4.   Notices. User hereby agrees not to remove, alter or destroy any
copyright, trademark, credits, other proprietary notices or confidential
legends placed upon, contained within or associated with the Software,
and shall include all such unaltered copyright, trademark, credits,
other proprietary notices or confidential legends on or in every copy of
the Software.

%prep
%setup -q -n riptide-0.4mbsibeta02122500

%build
make --quiet --no-print-directory all
%if "%{_target_kernel}" != "generic"

%if "%{_target_distro}" == "rh"
(
	if cd modules; then
		make --quiet --no-print-directory KERNELSRC=%{_distro_kernels}/RedHat/linux-%{_target_kernel} DISTRO_CFLAGS="-D__BOOT_KERNEL_H_ -D__BOOT_KERNEL_ENTERPRISE=0 -D__BOOT_KERNEL_SMP=0 -D__BOOT_KERNEL_UP=1 -D__MODULE_KERNEL_%{_target_cpu}=1" RIP_MODS_DIR=binaries/%{_target_cpu}/RedHat/linux-%{_target_kernel} clean all modules_install || exit $?
	fi
) || exit $?
%endif

%if "%{_target_distro}" == "mdk"
(
	if cd modules; then
		make --quiet --no-print-directory KERNELSRC=%{_distro_kernels}/Mandrake/linux-%{_target_kernel} DISTRO_CFLAGS="-D__BOOT_KERNEL_H_ -D__BOOT_KERNEL_ENTERPRISE=0 -D__BOOT_KERNEL_SMP=0 -D__BOOT_KERNEL_UP=1 -D__MODULE_KERNEL_%{_target_cpu}=1" RIP_MODS_DIR=binaries/%{_target_cpu}/Mandrake/linux-%{_target_kernel} clean all modules_install || exit $?
		ln -s i586 binaries/i686
		ln -s i586 binaries/athlon
	fi
) || exit $?
%endif

%if "%{_target_distro}" == "suse"
(
	if cd modules; then
		make --quiet --no-print-directory KERNELSRC=%{_distro_kernels}/SuSE/linux-%{_target_kernel} RIP_MODS_DIR=binaries/%{_target_cpu}/SuSE/linux-%{_target_kernel} clean all modules_install || exit $?
		ln -s i386 binaries/i486
		ln -s i386 binaries/i586
		ln -s i386 binaries/i686
		ln -s i386 binaries/athlon
	fi
) || exit $?
%endif

%endif

%install
rm -rf $RPM_BUILD_ROOT

make --quiet --no-print-directory ROOT=$RPM_BUILD_ROOT install

%clean
rm -rf $RPM_BUILD_ROOT

%files

%defattr(0555, root, root, 755)

%{sbindir}/ripconfig
%{sbindir}/ripstop

%defattr(0444, root, root, 755)
%{libdir}/riptide/riptide.hex
%dir %{libdir}/riptide
%doc %{libdir}/riptide/LICENSE
%dir %{libdir}/riptide/modules
%{libdir}/riptide/modules/binaries

%if %{automrecomp}
%config %{libdir}/riptide/config.mak
%attr(755, root, root) %{libdir}/riptide/modules/*.sh
%{libdir}/riptide/modules/[mM]akefile
%{libdir}/riptide/modules/common.mak
%{libdir}/riptide/modules/*.c
%{libdir}/riptide/modules/*.h
%endif

%doc BUGS CHANGES CREDITS FAQ INSTALL LICENSE README

%pre
if [ -e "%{libdir}/riptide" ]; then
	echo "Removing old %{libdir}/riptide"
	rm -rf "%{libdir}/riptide"
else
	exit 0
fi

%post
%if ! %{automrecomp}
RIP_AUTOCONFIG=true
%endif
if [ -n "${RIP_AUTOCONFIG}" -a -z "${RIP_NOAUTOCONFIG}" ]; then
	%{sbindir}/ripconfig --auto
	exit $?
else
	echo "To complete the installation and configuration of your RIPTIDE board,"
	echo "please run \"ripconfig\" (or \"%{sbindir}/ripconfig\")"
	exit 0
fi

%preun
if [ -z "${RIP_NOAUTOCONFIG}" ]; then
	%{sbindir}/ripconfig --remove
else
	exit 0
fi

# This must be last since the file CHANGES is automatically appended
%changelog


* Wed Dec 25 2002 Marc Boucher <marc@mbsi.ca>
	- Released riptide-0.4mbsibeta02122500.

* Wed Dec 25 2002 Marc Boucher <marc@mbsi.ca>
	- makefile: added Mandrake 9.0 linux-2.4.19-19mdk kernel.
	- makefile: added RedHat 2.4.18-19.7.x and 2.4.18-19.8.0 kernels.

* Sun Nov 03 2002 Marc Boucher <marc@mbsi.ca>
	- Released riptide-0.4mbsibeta02110301.

* Sun Nov 03 2002 Marc Boucher <marc@mbsi.ca>
	- modules/kernelcompiler.sh: use gcc 3 to build modules for
	SuSE's 2.4.19-4GB kernel.

* Sun Nov 03 2002 Marc Boucher <marc@mbsi.ca>
	- Released riptide-0.4mbsibeta02110300.

* Sun Nov 03 2002 Marc Boucher <marc@mbsi.ca>
	- makefile: added RedHat 2.4.18-17.7.x and 2.4.18-17.8.0 kernels.
	- makefile: added SuSE 2.4.19-4GB kernel.
	- modules/kernelcompiler.sh: use gcc 3 to build modules for
	RedHat's 2.4.18-17.8.0 kernel.
	- scripts/ripconfig.in: put module configuration in /etc/modules.d and
	run update-modules if present (for gentoo).

* Fri Oct 11 2002 Marc Boucher <marc@mbsi.ca>
	- Released riptide-0.4mbsibeta02101001.

* Fri Oct 11 2002 Marc Boucher <marc@mbsi.ca>
	- modules/kernelcompiler.sh: use gcc 3 to build modules for
	RedHat's 2.4.18-14 kernel.

* Thu Oct 10 2002 Marc Boucher <marc@mbsi.ca>
	- Released riptide-0.4mbsibeta02101000.

* Thu Oct 10 2002 Marc Boucher <marc@mbsi.ca>
	- makefile: added RedHat 8.0 linux-2.4.18-14 kernel.
	- makefile: added Mandrake 9.0 linux-2.4.19-16mdk kernel and
	removed obsolete SuSE 2.4.4-4GB kernel.
	- modules/kernelcompiler.sh: added gcc-2.96 (for Mandrake 9) and
	RPM_BUILD_ROOT support.

* Sun Sep 29 2002 Marc Boucher <marc@mbsi.ca>
	- makefile: tardist: changed way tar.gz files are generated to
	avoid gzip "decompression OK, trailing garbage ignored" messages.

* Wed Sep 18 2002 Marc Boucher <marc@mbsi.ca>
	- rt_hw.c:RipTideCreateChannel(): initialize pChannelInfo->sgdList
	to NULL. (Thanks to nokos@gmx.net for this fix)

* Sun Sep 01 2002 Marc Boucher <marc@mbsi.ca>
	- Released riptide-0.4mbsibeta02090100.

* Sun Sep 01 2002 Marc Boucher <marc@mbsi.ca>
	- modules/riptidem.c: rt_poll(): finally implemented! Debug msgs gone.
	Driver should now work with desktop audio daemons, such as KDE's artsd.
	- modules/riptidem.c: rt_read_dsp(), rt_write_dsp(): don't sleep if
	O_NONBLOCK.
	- scripts/ripconfig.in: added extra /etc/modules.conf aliases for
	automatic devfs module loading.
	- makefile: added Mandrake 2.4.18-8.1mdk kernel.
	- makefile: added RedHat 2.4.9-34, 2.4.18-5, and 2.4.18-10 kernels.
	- Added modules/kernelcompiler.sh, a small script which tries
	to guess which compiler should be used to build kernel modules.
	- modules/common.mak: use kernelcompiler.sh to determine default CC
	- modules/common.mak, INSTALL: added notes about KERNELSRC for
	Debian 3.0 users.

* Wed Jun 12 2002 Marc Boucher <marc@mbsi.ca>
	- Released riptide-0.3mbsibeta02061200.

* Wed Jun 12 2002 Marc Boucher <marc@mbsi.ca>
	- scripts/ripconfig.in: dynamically allocate sound-slot-N alias names.
	- modules/rt_mdl.c: do not request_region() for hwIOSynth as it
	conflicts with opl3 module.
	- modules/: silenced some debugging messages.

* Tue Jun 11 2002 Marc Boucher <marc@mbsi.ca>
	- Initial beta version (riptide-0.3mbsibeta02061100).
